local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_BossPercent"
local defaults = {

}
local options = {
}
local db
local last
local delayUpdate = .2

local function UpdateUnit(self)
	if(GetTime() < self['nextUpdate']) then return end
	self['nextUpdate'] = GetTime() + delayUpdate
	local unit = self:GetAttribute('unit')
--	print(unit)
	if(not unit) then return end
	local name = UnitName(unit)
	local health,maxHealth = UnitHealth(unit), UnitHealthMax(unit)
--	print(name, health,maxHealth)
	self['nfs']:SetText(name)
	if(self['pfs'] and maxHealth>0) then
		self['pfs']:SetFormattedText(addon:colorize("%.0f %%","ffbb88"),health / (maxHealth/100))
	end
	if(self['hsb'] and maxHealth>0) then
		self['hsb']:SetValue(health / (maxHealth/100))
	end
end

local function addUnit(group,groupName, unit,oldUnit, target)
-- print(unit,oldUnit,target)
	group.frames[unit] = CreateFrame("Button",groupName..unit,UIParent,  BackdropTemplateMixin and "SecureUnitButtonTemplate BackdropTemplate" or "SecureUnitButtonTemplate")
	group.frames[unit]:SetWidth(70)
	group.frames[unit]:SetHeight(target and 12 or 30)
	if(target) then
		group.frames[unit]:SetPoint("TOPLEFT",group.frames[oldUnit],"BOTTOMLEFT",0,-1)
	else
		group.frames[unit]:SetPoint("TOPLEFT",last,"TOPRIGHT",2,0)
	end
	
	group.frames[unit]:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
--		edgeFile = "Interface/Tooltips/UI-StatusBar-Border", 
		tile = true,
		tileSize = 1,
		edgeSize = 4, 
		insets = { left = 0, right = 0, top = 0, 0 }
	})
	group.frames[unit]:SetBackdropBorderColor(1,1,1,1)
	group.frames[unit]:SetBackdropColor(0,0,0,.5)
--	local tex = group:CreateTexture(); tex:SetAllPoints(); tex:SetTexture(0,0,0,.5);
	group.frames[unit]:SetAttribute("unit",unit)
	group.frames[unit]['nextUpdate'] = 0
	group.frames[unit]:SetScript("OnUpdate", UpdateUnit)

	local c = group.frames[unit]:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	c:SetWidth(64)
	c:SetHeight(12)
	c:SetPoint("TOPLEFT",group.frames[unit],"TOPLEFT",3,0)
	group.frames[unit]['nfs'] = c
	if(target==false) then
		local c = group.frames[unit]:CreateFontString(nil,"OVERLAY","CombatLogFont")
		c:SetWidth(64)
		c:SetHeight(18)
		c:SetJustifyH("CENTER")
		c:SetPoint("TOPLEFT",group.frames[unit],"TOPLEFT",3,-12)
		group.frames[unit]['pfs'] = c
		last = group.frames[unit]
	end
	local b = CreateFrame("StatusBar", "$PARENThealthbar", group.frames[unit])
	b:SetFrameStrata("BACKGROUND")
	b:SetWidth(64)
	b:SetHeight(12)
	b:SetPoint("TOPLEFT",group.frames[unit],"TOPLEFT",3 ,0)
	b:SetMinMaxValues(0,100)
	b:SetOrientation("HORIZONTAL")
	b:SetValue(100)
	b:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	b:GetStatusBarTexture():SetHorizTile(false)
	b:GetStatusBarTexture():SetVertTile(false)
	b:SetStatusBarColor(0,1,0,1)
	group.frames[unit]['hsb'] = b
	ClickCastFrames = ClickCastFrames or {}
	ClickCastFrames[group.frames[unit]] = true
	if(unit=='playertarget') then
		group.frames[unit]['db'] = db
		group.frames[unit]['dragAble'] = function() return not db['toggle'] end
		addon:AddDrag(group.frames[unit])
	end
	RegisterUnitWatch(group.frames[unit])
end

local function setupGroup(groupName,units)
	local group = CreateFrame("Frame",groupName,UIParent,"SecureHandlerBaseTemplate SecureGroupHeaderTemplate")
	group:SetWidth(5)
	group:SetHeight(5)
	group:SetPoint("CENTER",UIParent,"CENTER",-100,-50)
--	addon['loadFrame'](group)
--	addon['addDrag'](group,"BOX")
--	local tex = group:CreateTexture(); tex:SetAllPoints(); tex:SetTexture(1,1,0,1);
	group.frames = {}

	last = group
	
	for _,unit in pairs(units) do
		addUnit(group,groupName, unit, nil, false)
		addUnit(group,groupName, unit .. 'target',unit, true)
	end
--	group:Show()
	return group
end
local group
local function getPref(pref)
	return db[pref[#pref]]
end

local function setPref(pref,value)
	db[pref[#pref]] = value
	if(pref[#pref]=='toggle') then
		group.frames['playertarget']['locked'] = value
	end
end


local function init()
	options = addon:InitConfig(childName, true, {
		['name'] = childName,
		['type'] = "launcher",
	}, getPref, setPref)
	db = addon['db']['profile'][childName]
	addon:AddConfigEntry(childName, "toggle","toggle","Lock window",nil,1,nil,nil,nil,nil,options['args'][childName])
	group = setupGroup(childName.."Frames",{ "playertarget", "focus", "boss1","boss2","boss3"})
end
addon:startup(name, childName, init, true, defaults)